/* ###################################################################
**     Filename    : main.c
**     Project     : example_3
**     Processor   : MC9S08SE8CWL
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-10-23, 01:10, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "PTB.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "TM1637.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#define PORTB_D3 PTBD_PTBD3

void delay_2ms(uint8_t pause)
{   setReg8(RTCMOD, 0xFFU);//Start RTC. 
	while(RTCCNT < pause);
	setReg8(RTCMOD, 0x00);//Clear RTC.
}
void main(void)
{
  /* Write your local variable definition here */
	  signed int count=0, i=0;
	  uint8_t level =0; 
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
   PE_low_level_init();
  /*** End of Processor Expert internal initialization.***/     
    COPFree_Init();
    PTB_Init();
    setReg8(RTCSC, 0x43U); //RTC was configured for 2ms.  	
    setReg8(RTCMOD, 0x00U);
    PTBDD_PTBDD3=0;
    TM1637_Init();
    TM1637_DisplayDecimal(0,0,ENABLE_ZEROS); 
    delay_2ms(251);// 2 seg aprox.
    delay_2ms(251);
    delay_2ms(251);
    delay_2ms(251);
  /* Write your code here */
  /* For example: for(;;) { } */
  
  for(;;) {
	  
	  if(PORTB_D3==0) {
		 delay_2ms(5);
		if(PORTB_D3==0)level =1, delay_2ms(5);
	  }
	  if((PORTB_D3==1)&& (level==1))i++, level=0; 
	  
	  if(i>1)i=0;
	  if(count>9999)count=0;
	  if(count<0)count=9999;
	  
      TM1637_DisplayDecimal(count, 0, DISABLE_ZEROS); // 0: OFF 1: ON ,if you write DISABLE_ZEROS then xxx0...xx10...x100...1000
	  delay_2ms(251);// 1 seg aprox.
	  delay_2ms(251);
	  
	  if(i==0)count++; 
	  if(i==1)count--;
		  
  }

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
